# frozen_string_literal: true

module EdemRedirect
  module Builders
    class Url
      require 'jwt'

      def initialize(**args)
        @path = args[:path]
        @host = args[:host]
        @uid = args[:user_uid]
      end

      def call
        url = URI(ENV['ROUTER_REDIRECT_PATH'])
        url.query = URI.encode_www_form encode_params
        url.to_s
      end

      private

      def encode_params
        {
          token: JWT.encode(request_params, nil, 'none')
        }
      end

      def request_params
        {
          path: @path,
          host: @host,
          user_uid: @uid
        }
      end
    end
  end
end
